#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=FileRenamer.ico
#AutoIt3Wrapper_Outfile=FileRenamer.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=FileRenamer
#AutoIt3Wrapper_Res_Fileversion=2.3.0.0
#AutoIt3Wrapper_Res_LegalCopyright=by Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoTrayIcon
#include <ButtonConstants.au3>
#include <ListViewConstants.au3>
#include <Misc.au3>
#include <Array.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <File.au3>
#include <GuiStatusBar.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>

Opt('GUIOnEventMode', 1)

Global $sTitle = 'FileRenamer v2.3'
If _Singleton($sTitle, 1) = 0 Then Exit WinActivate($sTitle, '')

Global $aFiles
Global $sIni = @ScriptDir & '\FileRenamer.ini'
Global $sExtensions = IniRead($sIni, 'Prefs', 'Extensions', '')
If $sExtensions = '' Then
	$sExtensions = 'avi|bmp|doc|gif|html|jpg|mpg|mp3|odt|pdf|png|sxw|txt|wav|wma|wmv|xls|zip'
	IniWrite($sIni, 'Prefs', 'Extensions', $sExtensions)
EndIf

$hGui = GUICreate($sTitle, 390, 500)
GUISetOnEvent($GUI_EVENT_CLOSE, '_End')
GUISetBkColor(0xeeeeee)
GUISetIcon(@ScriptDir & '\FileRenamer.ico', -1)

$hFileMenu = GUICtrlCreateMenu('&Datei')
GUICtrlCreateMenuItem('Quellverzeichnis auswhlen', $hFileMenu)
GUICtrlSetOnEvent(-1, '_SelectSourceFolder')
GUICtrlCreateMenuItem('Zielverzeichnis auswhlen', $hFileMenu)
GUICtrlSetOnEvent(-1, '_SelectTargetFolder')
GUICtrlCreateMenuItem('', $hFileMenu)
GUICtrlCreateMenuItem('Beenden', $hFileMenu)
GUICtrlSetOnEvent(-1, '_End')
$hPrefMenu = GUICtrlCreateMenu('&Einstellungen')
$hPrefBubble = GUICtrlCreateMenuItem('Erklrungs-Sprechblasen anzeigen', $hPrefMenu)
GUICtrlSetOnEvent(-1, '_BubbleSwitch')
$hPrefMove = GUICtrlCreateMenuItem('Verschieben statt Kopieren', $hPrefMenu)
GUICtrlSetOnEvent(-1, '_MoveSwitch')
$hHelpMenu = GUICtrlCreateMenu('&Hilfe')
GUICtrlCreateMenuItem('ber FileRenamer', $hHelpMenu)
GUICtrlSetOnEvent(-1, '_About')

GUICtrlCreateGroup('Verzeichnisauswahl (Quelle):', 5, 10, 280, 50)
$hSourceFolder = GUICtrlCreateInput('', 10, 31, 240, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xdddddd)
$hSelectSource = GUICtrlCreateButton('...', 250, 30, 30, 22)
GUICtrlSetOnEvent(-1, '_SelectSourceFolder')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Dateiendung:', 290, 10, 95, 50)
$hSourceExt = GUICtrlCreateCombo('', 295, 30, 70, 22)
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetData(-1, $sExtensions, 'jpg')
GUICtrlSetOnEvent(-1, '_SourceExtSelect')
$hSourceSave = GUICtrlCreateButton('>', 366, 29, 14, 25)
GUICtrlSetFont(-1, 10, 600)
GUICtrlSetOnEvent(-1, '_AddExtension')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGroup('', -99, -99, 1, 1)

$hListView = GUICtrlCreateListView('Dateiauswahl', 5, 70, 380, 200, Default, BitOR($WS_EX_CLIENTEDGE, $LVS_EX_CHECKBOXES))
$hLVMenu = GUICtrlCreateContextMenu($hListView)
Global $ahLVMenu[3]
$ahLVMenu[0] = GUICtrlCreateMenuItem('Alle Dateien auswhlen', $hLVMenu)
GUICtrlSetOnEvent(-1, '_CheckedAll')
GUICtrlSetState(-1, $GUI_DISABLE)
$ahLVMenu[1] = GUICtrlCreateMenuItem('Keine Datei auswhlen', $hLVMenu)
GUICtrlSetOnEvent(-1, '_CheckedNone')
GUICtrlSetState(-1, $GUI_DISABLE)
$ahLVMenu[2] = GUICtrlCreateMenuItem('Datei ffnen (extern)', $hLVMenu)
GUICtrlSetOnEvent(-1, '_FileExecute')
GUICtrlSetState(-1, $GUI_DISABLE)
_GUICtrlListView_SetColumnWidth($hListView, 0, 355)

GUICtrlCreateGroup('Eingabe des neuen Dateinamen (ohne Dateiendung):', 5, 280, 280, 50)
$hTarget = GUICtrlCreateInput('', 10, 301, 270, 22)
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetBkColor(-1, 0xffffff)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Zhler-Start:', 290, 280, 95, 50)
$hCounter = GUICtrlCreateInput('1', 295, 300, 80, 22, BitOR($ES_NUMBER, $ES_RIGHT))
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetBkColor(-1, 0xffffff)
$hUpDown = GUICtrlCreateUpdown($hCounter)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Verzeichnisauswahl (Ziel):', 5, 340, 280, 50)
$hTargetFolder = GUICtrlCreateInput('', 10, 361, 240, 20, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xdddddd)
$hSelectTarget = GUICtrlCreateButton('...', 250, 360, 30, 22)
GUICtrlSetOnEvent(-1, '_SelectTargetFolder')
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Dateiendung:', 290, 340, 95, 50)
$hTargetExt = GUICtrlCreateCombo('', 295, 360, 70, 22)
GUICtrlSetFont(-1, 9, 600)
GUICtrlSetData(-1, $sExtensions, 'jpg')
$hTargetSave = GUICtrlCreateButton('>', 366, 359, 14, 25)
GUICtrlSetFont(-1, 10, 600)
GUICtrlSetOnEvent(-1, '_AddExtension')
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateGroup('', -99, -99, 1, 1)

GUICtrlCreateGroup('Neuer Dateiname (Vorschau):', 5, 400, 280, 50)
$hPreview = GUICtrlCreateInput('', 10, 420, 270, 22, BitOR($ES_READONLY, $ES_AUTOHSCROLL))
GUICtrlSetFont(-1, 9, 400)
GUICtrlSetBkColor(-1, 0xddffdd)
GUICtrlSetLimit(-1, 1)
GUICtrlCreateGroup('', -99, -99, 1, 1)

$hStart = GUICtrlCreateButton('Dateien Umbenennen', 290, 405, 95, 45, $BS_MULTILINE)
GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
GUICtrlSetOnEvent(-1, '_Start')
GUICtrlSetState(-1, $GUI_DISABLE)
$hStatus = _GUICtrlStatusBar_Create($hGui)

$bBubble = Not Execute(IniRead($sIni, 'Prefs', 'BubbleHelp', True))
_BubbleSwitch()

$bMove = Not Execute(IniRead($sIni, 'Prefs', 'MoveCopy', False))
_MoveSwitch()

GUISetState()
GUIRegisterMsg($WM_COMMAND, 'MY_WM_COMMAND')
GUIRegisterMsg($WM_NOTIFY, 'MY_WM_NOTIFY')

While True
	Sleep(50)
WEnd

Func _About()
	Local $msg = $sTitle & @CRLF & 'vom: 31. Oktober 2016' & @CRLF
	$msg &= 'Programmiert von: Oscar (www.autoit.de)'
	MsgBox(262144 + 64, 'ber...', $msg, 0, $hGui)
EndFunc   ;==>_About

Func _End()
	Exit
EndFunc   ;==>_End

Func MY_WM_NOTIFY($hWnd, $msg, $wParam, $lParam)
	Local $nID = BitAND($wParam, 0x0000FFFF)
	Switch $nID
		Case $hUpDown
			Local $aContrPos = ControlGetPos($hGUI, '', $hUpDown)
			If Not IsArray($aContrPos) Then Return 1
			Local $aMousePos = GUIGetCursorInfo($hGUI)
			If Not IsArray($aMousePos) Then Return 1
			If $aMousePos[1] > $aContrPos[1] + $aContrPos[3] / 2 Then
				GUICtrlSetData($hCounter, GUICtrlRead($hCounter) - 1)
			Else
				GUICtrlSetData($hCounter, GUICtrlRead($hCounter) + 1)
			EndIf
			Return 1
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>MY_WM_NOTIFY

Func MY_WM_COMMAND($hWnd, $msg, $wParam, $lParam)
	Local $nID = BitAND($wParam, 0x0000FFFF), $sExt
	Switch $nID
		Case $hTarget, $hCounter
			_RefreshPreview()
		Case $hSourceExt
			Local $sTmp = GUICtrlRead($hSourceExt)
			If StringLen($sTmp) > 4 Then
				$sTmp = StringLeft($sTmp, 4)
				GUICtrlSetData($hSourceExt, $sTmp)
			EndIf
			If StringRegExp('|' & $sExtensions & '|', '\|' & $sTmp & '\|') Then
				GUICtrlSetState($hSourceSave, $GUI_DISABLE)
			Else
				GUICtrlSetState($hSourceSave, $GUI_ENABLE)
			EndIf
		Case $hTargetExt
			Local $sTmp = GUICtrlRead($hTargetExt)
			If StringLen($sTmp) > 4 Then
				$sTmp = StringLeft($sTmp, 4)
				GUICtrlSetData($hTargetExt, $sTmp)
			EndIf
			If StringRegExp('|' & $sExtensions & '|', '\|' & $sTmp & '\|') Then
				GUICtrlSetState($hTargetSave, $GUI_DISABLE)
			Else
				GUICtrlSetState($hTargetSave, $GUI_ENABLE)
			EndIf
			_RefreshPreview()
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>MY_WM_COMMAND

Func _RefreshPreview()
	Local $iNumber
	Local $iCount = StringReplace(GUICtrlRead($hCounter), '.', '')
	If $iCount < 0 Then $iCount = Not GUICtrlSetData($hCounter, 0)
	Local $sExtension = '.' & StringRegExpReplace(GUICtrlRead($hTargetExt), '[\:\*\?\\\/]', '')
	Local $sTmpTarget = GUICtrlRead($hTarget)
	If StringRegExp($sTmpTarget, '[\|\:\*\?\\\/]') Then GUICtrlSetData($hTarget, StringRegExpReplace($sTmpTarget, '[\|\:\*\?\\\/]', ''))
	Local $sNewFileName = StringRegExpReplace($sTmpTarget, '[\:\*\?\\\/]', '')
	If IsArray($aFiles) Then
		$iNumber = _GUICtrlListView_GetCheckedCount($hListView) - 1
	Else
		$iNumber = 1
	EndIf
	Local $sOldName = ControlListView($hGui, '', $hListView, 'GetText', 0, 0)
	Local $sPreview = StringRegExpReplace(_NewName($sNewFileName, $iCount, $iNumber, $sExtension, $sOldName), '.*\\(.+)', '$1')
	GUICtrlSetData($hPreview, $sPreview)
EndFunc   ;==>_RefreshPreview

Func _AddExtension()
	Switch @GUI_CtrlId
		Case $hSourceSave
			Local $sExt = StringLower(GUICtrlRead($hSourceExt))
		Case $hTargetSave
			Local $sExt = StringLower(GUICtrlRead($hTargetSave))
	EndSwitch
	If $sExt = '>' Then Return
	If Not StringRegExp('|' & $sExtensions & '|', '\|' & $sExt & '\|') Then _SaveExtension($sExt)
EndFunc   ;==>_AddExtension

Func _SaveExtension($sExt)
	Local $aExt = StringSplit($sExtensions, '|', 2)
	_ArrayAdd($aExt, $sExt)
	_ArraySort($aExt)
	$sExtensions = _ArrayToString($aExt)
	IniWrite($sIni, 'Prefs', 'Extensions', $sExtensions)
	GUICtrlSetData($hSourceExt, '')
	GUICtrlSetData($hSourceExt, $sExtensions, $sExt)
	GUICtrlSetData($hTargetExt, '')
	GUICtrlSetData($hTargetExt, $sExtensions, $sExt)
	GUICtrlSetState($hSourceSave, $GUI_DISABLE)
	GUICtrlSetState($hTargetSave, $GUI_DISABLE)
EndFunc   ;==>_SaveExtension

Func _FileExecute()
	Local $sFile = ControlListView($hGui, '', $hListView, 'GetText', ControlListView($hGui, '', $hListView, 'GetSelected'))
	Local $sPath = GUICtrlRead($hSourceFolder)
	ShellExecute($sPath & $sFile)
EndFunc   ;==>_FileExecute

Func _CheckedAll()
	_GUICtrlListView_SetItemChecked($hListView, -1, True)
	_RefreshCounter()
EndFunc   ;==>_CheckedAll

Func _CheckedNone()
	_GUICtrlListView_SetItemChecked($hListView, -1, False)
	_RefreshCounter()
EndFunc   ;==>_CheckedNone

Func _RefreshCounter()
	_RefreshPreview()
	Local $iChecked = _GUICtrlListView_GetCheckedCount($hListView)
	_GUICtrlStatusBar_SetText($hStatus, $aFiles[0] & ' Datei' & StringMid('en', 1 + ($aFiles[0] = 1) * 2, 2) & ' gefunden.   ' _
			 & $iChecked & ' Datei' & StringMid('en', 1 + ($iChecked = 1) * 2, 2) & ' ausgewhlt.')
EndFunc   ;==>_RefreshCounter

Func _GUICtrlListView_GetCheckedItemsTextArray($hListView)
	Local $aCheckedItems = _GUICtrlListView_GetCheckedIndices($hListView)
	Local $iCheckedCount = UBound($aCheckedItems)
	If $iCheckedCount = 0 Then Return SetError(1, 0, 0)
	Local $iColCount = _GUICtrlListView_GetColumnCount($hListView)
	Local $aCheckedItemsText[$iCheckedCount][$iColCount], $aTemp
	For $i = 0 To $iCheckedCount - 1
		$aTemp = _GUICtrlListView_GetItemTextArray($hListView, $aCheckedItems[$i])
		For $j = 1 To $aTemp[0]
			$aCheckedItemsText[$i][$j - 1] = $aTemp[$j]
		Next
	Next
	Return $aCheckedItemsText
EndFunc   ;==>_GUICtrlListView_GetCheckedItemsTextArray

Func _GUICtrlListView_GetCheckedIndices($hListView)
	Local $iCount = _GUICtrlListView_GetItemCount($hListView)
	Local $iCheckedCount = _GUICtrlListView_GetCheckedCount($hListView)
	If $iCheckedCount = 0 Then Return SetError(1, 0, 0)
	Local $aCheckedItems[$iCheckedCount]
	$iCheckedCount = 0
	For $i = 0 To $iCount - 1
		If _GUICtrlListView_GetItemChecked($hListView, $i) Then
			$aCheckedItems[$iCheckedCount] = $i
			$iCheckedCount += 1
		EndIf
	Next
	Return $aCheckedItems
EndFunc   ;==>_GUICtrlListView_GetCheckedIndices

Func _GUICtrlListView_GetCheckedCount($hListView)
	Local $iCount = _GUICtrlListView_GetItemCount($hListView), $iCheckedCount = 0
	If $iCount = 0 Then Return SetError(1, 0, 0)
	For $i = 0 To $iCount - 1
		$iCheckedCount += _GUICtrlListView_GetItemChecked($hListView, $i)
	Next
	Return $iCheckedCount
EndFunc   ;==>_GUICtrlListView_GetCheckedCount

Func _MoveSwitch()
	$bMove = Not $bMove
	If $bMove Then
		GUICtrlSetState($hPrefMove, $GUI_CHECKED)
	Else
		GUICtrlSetState($hPrefMove, $GUI_UNCHECKED)
	EndIf
	IniWrite($sIni, 'Prefs', 'MoveCopy', $bMove)
	_StartButtonText()
EndFunc   ;==>_MoveSwitch

Func _BubbleSwitch()
	$bBubble = Not $bBubble
	If $bBubble Then
		GUICtrlSetState($hPrefBubble, $GUI_CHECKED)
		GUICtrlSetTip($hSourceFolder, 'Das Quellverzeichnis mit den umzubenennenden Dateien.', $sTitle, 1, 1)
		GUICtrlSetTip($hTargetFolder, 'Wenn das Zielverzeichnis vom Quellverzeichnis abweicht,' & @CRLF & 'werden die Dateien im Quellverzeichnis nicht' _
				 & ' umbenannt,' & @CRLF & 'sondern mit dem neuen Namen ins Zielverzeichnis kopiert' & @CRLF & 'bzw. verschoben.', $sTitle, 1, 1)
		GUICtrlSetTip($hSelectSource, 'Quellverzeichnis auswhlen.', $sTitle, 1, 1)
		GUICtrlSetTip($hSelectTarget, 'Zielverzeichnis auswhlen.', $sTitle, 1, 1)
		GUICtrlSetTip($hSourceExt, 'Die Dateiendung vor dem Umbenennen (ohne Punkt)', $sTitle, 1, 1)
		GUICtrlSetTip($hListView, 'Die Dateien auswhlen, die umbenannt bzw. kopiert werden sollen.' & @CRLF _
				 & 'Kontextmen (rechte Maustaste) mit weiteren Funktionen vorhanden.', $sTitle, 1, 1)
		GUICtrlSetTip($hTarget, 'Bedeutung der Platzhalter:' & @CRLF & @CRLF & '###...' & @TAB & '= Position und Anzahl der Stellen des Zhlers' & @CRLF _
				 & '%s' & @TAB & '= Alter Dateiname (ohne Dateiendung)' & @CRLF & @CRLF & '%yyyy' & @TAB & '= Erstellungsdatum der Datei (Jahr, 4stellig)' & @CRLF _
				 & '%mm' & @TAB & '= Erstellungsdatum der Datei (Monat, 2stellig)' & @CRLF & '%dd' & @TAB & '= Erstellungsdatum der Datei (Tag, 2stellig)' & @CRLF _
				 & '%HH' & @TAB & '= Erstellungsuhrzeit der Datei (Stunden, 2stellig)' & @CRLF & '%MM' & @TAB & '= Erstellungsuhrzeit der Datei (Minuten, 2stellig)' & @CRLF _
				 & '%SS' & @TAB & '= Erstellungsuhrzeit der Datei (Sekunden, 2stellig)', $sTitle, 1, 1)
		GUICtrlSetTip($hCounter, 'Bei welchem Zhlerstand soll das Umbenennen beginnen?', $sTitle, 1, 1)
		GUICtrlSetTip($hTargetExt, 'Die Dateiendung nach dem Umbenennen (ohne Punkt)', $sTitle, 1, 1)
		GUICtrlSetTip($hPreview, 'So wrden die Dateien nach dem Umbenennen aussehen.', $sTitle, 1, 1)
		GUICtrlSetTip($hStart, 'Bearbeitung beginnen.', $sTitle, 1, 1)
		GUICtrlSetTip($hSourceSave, 'Neue Dateiendung in Inidatei speichern', $sTitle, 1, 1)
		GUICtrlSetTip($hTargetSave, 'Neue Dateiendung in Inidatei speichern', $sTitle, 1, 1)
	Else
		GUICtrlSetState($hPrefBubble, $GUI_UNCHECKED)
		GUICtrlSetTip($hSourceFolder, '')
		GUICtrlSetTip($hTargetFolder, '')
		GUICtrlSetTip($hSelectSource, '')
		GUICtrlSetTip($hSelectTarget, '')
		GUICtrlSetTip($hSourceExt, '')
		GUICtrlSetTip($hListView, '')
		GUICtrlSetTip($hTarget, '')
		GUICtrlSetTip($hCounter, '')
		GUICtrlSetTip($hTargetExt, '')
		GUICtrlSetTip($hPreview, '')
		GUICtrlSetTip($hStart, '')
		GUICtrlSetTip($hSourceSave, '')
		GUICtrlSetTip($hTargetSave, '')
	EndIf
	IniWrite($sIni, 'Prefs', 'BubbleHelp', $bBubble)
EndFunc   ;==>_BubbleSwitch

Func _Start()
	Local $aChecked = _GUICtrlListView_GetCheckedItemsTextArray($hListView)
	Local $iCheckedCount = UBound($aChecked) - 1
	Local $iCount = StringReplace(GUICtrlRead($hCounter), '.', '')
	Local $sExtension = '.' & StringRegExpReplace(GUICtrlRead($hTargetExt), '[\:\.\*\?\\\/]', '')
	Local $sPath = GUICtrlRead($hSourceFolder)
	Local $sNewFileName = StringRegExpReplace(GUICtrlRead($hTarget), '[\:\*\?\\\/]', '')
	For $i = 0 To $iCheckedCount
		While FileExists(_NewName($sNewFileName, $iCount, $iCheckedCount, $sExtension, $aChecked[$i][0]))
			$iCount += 1
		WEnd
		Local $sTmp = _NewName($sNewFileName, $iCount, $iCheckedCount, $sExtension, $aChecked[$i][0])
		If (StringRegExpReplace($sTmp, '(.+\\).+\z', '$1') = $sPath) Or ($bMove = True) Then
			FileMove($sPath & $aChecked[$i][0], $sTmp)
			_GUICtrlStatusBar_SetText($hStatus, ' Bearbeite ' & $aChecked[$i][0])
		Else
			FileCopy($sPath & $aChecked[$i][0], $sTmp)
			_GUICtrlStatusBar_SetText($hStatus, ' Kopiere ' & $aChecked[$i][0])
		EndIf
		$iCount += 1
	Next
	SoundPlay(@WindowsDir & '\Media\notify.wav')
	_GUICtrlStatusBar_SetText($hStatus, ' ' & $iCheckedCount + 1 & ' Datei(en) umbenannt/kopiert.')
	Sleep(3000)
	_ReadFolder($sPath)
EndFunc   ;==>_Start

Func _NewName($sNewFileName, $iCount, $iFiles, $sExtension, $sOldName)
	Local $iStart = StringReplace(GUICtrlRead($hCounter), '.', '')
	Local $sPath = GUICtrlRead($hTargetFolder)
	Local $sOut = $sPath
	Local $aPos = StringRegExp($sNewFileName, '\#+', 3)
	Local $sTmp
	Local $aDate = FileGetTime($sPath & $sOldName, 0) ; 1 = Erstellungsdatum
	If Not IsArray($aDate) Then Local $aDate[6] = [@YEAR, @MON, @MDAY, @HOUR, @MIN, @SEC]
	$sNewFileName = StringReplace($sNewFileName, '%yyyy', $aDate[0], 0, 1)
	$sNewFileName = StringReplace($sNewFileName, '%mm', $aDate[1], 0, 1)
	$sNewFileName = StringReplace($sNewFileName, '%dd', $aDate[2], 0, 1)
	$sNewFileName = StringReplace($sNewFileName, '%HH', $aDate[3], 0, 1)
	$sNewFileName = StringReplace($sNewFileName, '%MM', $aDate[4], 0, 1)
	$sNewFileName = StringReplace($sNewFileName, '%SS', $aDate[5], 0, 1)
	$sOldName = StringRegExpReplace($sOldName, '\..+\z', '')
	$sNewFileName = StringReplace($sNewFileName, '%s', $sOldName, 0, 1)
	If IsArray($aPos) Then
		For $i = 0 To UBound($aPos) - 1
			If StringLen($iStart + $iFiles) > StringLen($aPos[$i]) Then
				$sTmp = StringFormat('%0' & StringLen($iStart + $iFiles) & 'i', $iCount)
			Else
				$sTmp = StringFormat('%0' & StringLen($aPos[$i]) & 'i', $iCount)
			EndIf
			$sNewFileName = StringReplace($sNewFileName, $aPos[$i], $sTmp, 1)
		Next
		$sOut &= $sNewFileName
	Else
		$sTmp = StringFormat('%0' & StringLen($iStart + $iFiles) & 'i', $iCount)
		$sOut &= $sNewFileName & '_' & $sTmp
	EndIf
	Return $sOut & $sExtension
EndFunc   ;==>_NewName

Func _SourceExtSelect()
	Local $sPath = GUICtrlRead($hSourceFolder)
	If $sPath <> '' Then _ReadFolder($sPath)
EndFunc   ;==>_SourceExtSelect

Func _SelectSourceFolder()
	Local $sSource = IniRead($sIni, 'Path', 'Source', @ScriptDir)
	Local $sPath = FileSelectFolder('Bitte Verzeichnis auswhlen', '', 0, $sSource, $hGui)
	If FileExists($sPath) Then
		If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
		IniWrite($sIni, 'Path', 'Source', $sPath)
		GUICtrlSetData($hSourceFolder, $sPath)
		GUICtrlSetData($hTargetFolder, $sPath)
		_ReadFolder($sPath)
		_StartButtonText()
	EndIf
EndFunc   ;==>_SelectSourceFolder

Func _StartButtonText()
	If GUICtrlRead($hTargetFolder) <> GUICtrlRead($hSourceFolder) Then
		Switch $bMove
			Case True
				GUICtrlSetData($hStart, 'Dateien Verschieben')
			Case False
				GUICtrlSetData($hStart, 'Dateien Kopieren')
		EndSwitch
	Else
		GUICtrlSetData($hStart, 'Dateien Umbenennen')
	EndIf
EndFunc   ;==>_StartButtonText

Func _SelectTargetFolder()
	Local $sTarget = GUICtrlRead($hSourceFolder)
	Local $sPath = FileSelectFolder('Bitte Verzeichnis auswhlen', '', 1, $sTarget, $hGui)
	If FileExists($sPath) Then
		If StringRight($sPath, 1) <> '\' Then $sPath &= '\'
		GUICtrlSetData($hTargetFolder, $sPath)
		_StartButtonText()
	EndIf
EndFunc   ;==>_SelectTargetFolder

Func _ReadFolder($sPath)
	Local $sExtension = StringReplace(GUICtrlRead($hSourceExt), '.', '')
	_GUICtrlListView_DeleteAllItems($hListView)
	$aFiles = _FileListToArray($sPath, '*.' & $sExtension, 1)
	If Not @error Then
		GUICtrlSetState($hStart, $GUI_ENABLE)
		For $i = 1 To $aFiles[0]
			GUICtrlCreateListViewItem($aFiles[$i], $hListView)
			GUICtrlSetOnEvent(-1, '_RefreshCounter')
		Next
		For $i = 0 To 2
			GUICtrlSetState($ahLVMenu[$i], $GUI_ENABLE)
		Next
		_CheckedAll()
	Else
		GUICtrlSetState($hStart, $GUI_DISABLE)
		For $i = 0 To 2
			GUICtrlSetState($ahLVMenu[$i], $GUI_DISABLE)
		Next
		_GUICtrlStatusBar_SetText($hStatus, ' Keine Dateien gefunden.')
	EndIf
EndFunc   ;==>_ReadFolder